"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path = __importStar(require("path"));
var loaders_1 = __importDefault(require("./loaders"));
var AbstractBundler_1 = __importDefault(require("./AbstractBundler"));
var EnvironmentTypes_1 = require("./types/EnvironmentTypes");
var UmdBundler = (function (_super) {
    __extends(UmdBundler, _super);
    function UmdBundler(mode, name, entryPath, config) {
        if (mode === void 0) { mode = EnvironmentTypes_1.EnvironmentTypes.Development; }
        if (config === void 0) { config = {}; }
        var _this = _super.call(this, mode, config) || this;
        _this.config.webpack.devServer.open = false;
        _this.webpackChain.output.globalObject("(typeof self !== 'undefined' ? self : this)");
        _this.webpackChain.entry(name).add(path.join(_this.config.root, entryPath));
        _this.updateJavascriptLoaders();
        new loaders_1.default.Sass(_this, {
            hashType: _this.config.hashType,
        });
        _this.webpackChain.output.filename("[name].umd.js");
        _this.webpackChain.output.library(name);
        _this.webpackChain.output.libraryTarget("umd");
        _this.webpackChain.output.libraryExport("default");
        _this.webpackChain.optimization.splitChunks({}).runtimeChunk(false);
        if (_this.env.isHot) {
            _this.webpackChain.devServer.set("writeToDisk", function (filePath) {
                return (new RegExp(_this.config.outputPath + ".*").test(filePath) &&
                    !/hot-update\.(js|json)$/.test(filePath));
            });
        }
        _this.config.bundleName = name + " Bundle";
        return _this;
    }
    return UmdBundler;
}(AbstractBundler_1.default));
exports.default = UmdBundler;
//# sourceMappingURL=UmdBundler.js.map