"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Plugin_1 = __importDefault(require("./Plugin"));
var html_webpack_plugin_1 = __importDefault(require("html-webpack-plugin"));
var Html = (function (_super) {
    __extends(Html, _super);
    function Html() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Html.prototype.register = function () {
        var config = {
            inject: true,
            template: "./index.html",
        };
        for (var variableName in this.options.variables) {
            config[variableName] = this.options.variables[variableName];
        }
        this.bundler.webpackChain.plugin("html").use(html_webpack_plugin_1.default, [config]);
    };
    return Html;
}(Plugin_1.default));
exports.default = Html;
//# sourceMappingURL=Html.js.map