"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var runs = 0;
var scripts = [];
var previousData = null;
var safariFix = "!function(){var e=document,t=e.createElement(\"script\");if(!(\"noModule\"in t)&&\"onbeforeload\"in t){var n=!1;e.addEventListener(\"beforeload\",function(e){if(e.target===t)n=!0;else if(!e.target.hasAttribute(\"nomodule\")||!n)return;e.preventDefault()},!0),t.type=\"module\",t.src=\".\",e.head.appendChild(t),t.remove()}}();";
var MultiBuildHtml = (function () {
    function MultiBuildHtml() {
    }
    MultiBuildHtml.prototype.apply = function (compiler) {
        var _this = this;
        var tapName = "multi-build";
        compiler.hooks.compilation.tap(tapName, function (compilation) {
            compilation.hooks.htmlWebpackPluginBeforeHtmlGeneration.tapAsync(tapName, function (data, cb) {
                scripts = scripts.concat(data.assets.js);
                data.plugin.options.scripts = scripts;
                cb(null, data);
            });
            compilation.hooks.htmlWebpackPluginAlterAssetTags.tapAsync(tapName, function (data, cb) { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    runs++;
                    if (runs === 2) {
                        data.body = data.body.concat(previousData.body);
                        data.head = data.head.concat(previousData.head);
                        data.body = data.body.filter(function (tag, index, self) {
                            return (index ===
                                self.findIndex(function (selfTag) {
                                    return !tag.attributes ||
                                        (tag.attributes.src === selfTag.attributes.src &&
                                            tag.attributes.rel === selfTag.attributes.rel);
                                }));
                        });
                        data.body.forEach(function (tag) {
                            if (tag.tagName === "script" && tag.attributes) {
                                if (tag.attributes.src.includes(".legacy.js")) {
                                    return (tag.attributes.nomodule = "");
                                }
                                return (tag.attributes.type = "module");
                            }
                            return null;
                        });
                        data.head = data.head.filter(function (tag, index, self) {
                            return (index ===
                                self.findIndex(function (selfTag) {
                                    return !tag.attributes ||
                                        (tag.attributes.href === selfTag.attributes.href &&
                                            tag.attributes.rel === selfTag.attributes.rel);
                                }));
                        });
                        data.head.forEach(function (tag) {
                            if (tag.tagName === "link" &&
                                tag.attributes &&
                                tag.attributes.as === "script" &&
                                tag.attributes.rel === "preload") {
                                tag.attributes.rel = "modulepreload";
                            }
                        });
                        data.body.unshift({
                            tagName: "script",
                            closeTag: true,
                            innerHTML: safariFix,
                        });
                        data.plugin.options.inject = true;
                    }
                    else {
                        previousData = data;
                        data.plugin.options.inject = false;
                    }
                    cb();
                    return [2];
                });
            }); });
            compilation.hooks.htmlWebpackPluginAfterHtmlProcessing.tap(tapName, function (data) {
                data.html = data.html.replace(/\snomodule="">/g, " nomodule>");
            });
        });
    };
    return MultiBuildHtml;
}());
exports.default = MultiBuildHtml;
//# sourceMappingURL=MultiBuild.js.map