import Bundler from "../interfaces/Bundler";
export default abstract class Loader<T> {
    protected options: T;
    protected bundler: Bundler;
    constructor(bundler: Bundler, options?: T);
    abstract register(): void;
    generateCacheConfig(loader: any, relatedPackages?: any[], configFiles?: any[]): {
        cacheIdentifier: any;
        cacheDirectory: string;
    };
    private getPath;
    private getFile;
}
