"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Plugin_1 = __importDefault(require("./Plugin"));
var browser_sync_webpack_plugin_1 = __importDefault(require("browser-sync-webpack-plugin"));
var BrowserSync = (function (_super) {
    __extends(BrowserSync, _super);
    function BrowserSync() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    BrowserSync.prototype.register = function () {
        this.bundler.webpackChain.plugin("browser-sync").use(browser_sync_webpack_plugin_1.default, [
            {
                port: this.options.port,
                host: this.options.host,
                proxy: this.options.proxy,
                open: this.options.host === "0.0.0.0" ? "local" : "external",
                files: [
                    this.options.outputPath + "/**/*.js",
                    this.options.outputPath + "**/*.css",
                ],
            },
            { reload: false },
        ]);
    };
    return BrowserSync;
}(Plugin_1.default));
exports.default = BrowserSync;
//# sourceMappingURL=BrowserSync.js.map