"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var hash_sum_1 = __importDefault(require("hash-sum"));
var Plugin_1 = __importDefault(require("./Plugin"));
var NamedChunksPlugin_1 = __importDefault(require("webpack/lib/NamedChunksPlugin"));
var NamedChunks = (function (_super) {
    __extends(NamedChunks, _super);
    function NamedChunks() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    NamedChunks.prototype.register = function () {
        this.bundler.webpackChain.plugin("named-chunks").use(NamedChunksPlugin_1.default, [
            function (chunk) {
                if (chunk.name) {
                    return chunk.name;
                }
                var joinedHash = (0, hash_sum_1.default)(Array.from(chunk.modulesIterable, function (m) {
                    return m.id;
                }).join("_"));
                return "chunk-" + joinedHash;
            },
        ]);
    };
    return NamedChunks;
}(Plugin_1.default));
exports.default = NamedChunks;
//# sourceMappingURL=NamedChunks.js.map