"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Copy_1 = __importDefault(require("./Copy"));
var Html_1 = __importDefault(require("./Html"));
var Clean_1 = __importDefault(require("./Clean"));
var Preload_1 = __importDefault(require("./Preload"));
var PurgeCss_1 = __importDefault(require("./PurgeCss"));
var WebpackBar_1 = __importDefault(require("./WebpackBar"));
var BundleAnalyzer_1 = __importDefault(require("./BundleAnalyzer"));
var CaseSensitivePaths_1 = __importDefault(require("./CaseSensitivePaths"));
var AggressiveSplitting_1 = __importDefault(require("./AggressiveSplitting"));
var DefineEnvironmentVariables_1 = __importDefault(require("./DefineEnvironmentVariables"));
exports.default = {
    Copy: Copy_1.default,
    Html: Html_1.default,
    Clean: Clean_1.default,
    Preload: Preload_1.default,
    PurgeCss: PurgeCss_1.default,
    WebpackBar: WebpackBar_1.default,
    BundleAnalyzer: BundleAnalyzer_1.default,
    CaseSensitivePaths: CaseSensitivePaths_1.default,
    AggressiveSplitting: AggressiveSplitting_1.default,
    DefineEnvironmentVariables: DefineEnvironmentVariables_1.default,
};
//# sourceMappingURL=index.js.map